代码随想录算法训练营day41|动态规划买卖股票问题

今天的三题买卖股票问题,实际上解题方法都大同小异,思路也和昨天的树形dp有相似之处,都是用一个dp数组的不同下标来记录不同的状态。其中第一题是只买卖一次,可以用贪心的方法,找出左边的最小值和右边的最大值,相减即可最大利润。如果用动态规划的方法,则分别用0和1来表示持有股票和不持有股票,dpi0和dpi1表示当前拥有的现金,则持有股票就减去pricei,卖出股票就加上pricei,又因为这题只卖出一次,所以可以列出如下方程:

复制代码
            dp[i][0] = max(dp[i - 1][0], -prices[i]);
            dp[i][1] = max(dp[i - 1][1], prices[i] + dp[i - 1][0]);

第二题与第一题的区别在于买卖次数没有限制,则方程应更改为下图:

复制代码
            dp[i][0] = max(dp[i - 1][0], dp[i - 1][1]-price[i]);
            dp[i][1] = max(dp[i - 1][1], dp[i - 1][0]+price[i]);

同时第二题也可以使用贪心,将每次买卖都拆解开,

复制代码
interest=price[3]-price[2]+price[2]-price[1]+price[1]-price[0]

所以将正数部分累加即可得到最大值。

第三题与第一题的区别在于买卖次数上限改为两次,不好用贪心。考虑dp代码如下:

复制代码
            dp[i][1] = max(dp[i - 1][1], dp[i - 1][0] - prices[i]);
            dp[i][2] = max(dp[i - 1][2], dp[i - 1][1] + prices[i]);
            dp[i][3] = max(dp[i - 1][3], dp[i - 1][2] - prices[i]);
            dp[i][4] = max(dp[i - 1][4], dp[i - 1][3] + prices[i]);

注意到每一次的状态只跟前一次有关,所以可以进行降维处理,这里卡哥采用正序遍历,我觉得类似一维01背包的倒序遍历更好理解:

复制代码
            dp[4]=max(dp[4],dp[3]+prices[i]); 
            dp[3]=max(dp[3],dp[2]-prices[i]);   
            dp[2]=max(dp[2],dp[1]+prices[i]);
            dp[1]=max(dp[1],-prices[i]);

采用倒序遍历保证每一次的数值在计算前不会被覆盖

相关推荐
纪念 22928 分钟前
C++算法(三)
开发语言·c++·算法
学不会pwn不改名42 分钟前
时间复杂度与空间复杂度详解
算法
AbandonForce1 小时前
递归、搜索与回溯:从板书到二叉树解题方法
c++·算法·决策树
打工仔折腾 AI1 小时前
让时序预测真正参与决策:TimechoAI 工程化落地与管线设计实践
人工智能·后端·python·算法·机器学习·性能优化
Light601 小时前
企业自建 AI 智能体,成本差 8 倍还是 46 倍?
java·人工智能·算法·知识图谱·rag·ai agent 上下文·token 成本
曹牧1 小时前
VS: Visual Studio 里把未包含的文件加进项目2
linux·运维·算法
重生之小比特2 小时前
【算法拾光】滑动窗口|长度最小的子数组 + 无重复字符的最长子串
算法
weixin_307779132 小时前
C++代码实现MATLAB中的fitnlm函数功能
开发语言·c++·算法·matlab
雪落漂泊2 小时前
C++算法:双指针篇(下)
数据结构·c++·算法